
class Funktion {
	public void printFunktionswert(int x) {
		System.out.println(x);
	}
}

class QuadratFunktion extends Funktion {

	@Override
	public void printFunktionswert(int x) {
		System.out.println(x * x);
	}
}

class Sqrt extends Funktion {

	@Override
	public void printFunktionswert(int x) {
		System.out.println(Math.sqrt(x));
	}
}

class FunktionArrayList {

	Funktion[] funktionen;
	int next;

	public FunktionArrayList() {
		this.funktionen = new Funktion[10];
		this.next = 0;
	}

	public void add(Funktion f) {
		this.checkIncrease();
		this.funktionen[this.next++] = f;
	}

	public void ausgeben(int x) {
		for (int i = 0; i < this.next; i++) {
			this.funktionen[i].printFunktionswert(x);
		}
	}
	
	private void checkIncrease() {
		if (this.next == this.funktionen.length) {
			Funktion[] copy = new Funktion[this.funktionen.length * 2];
			for (int i = 0; i < this.funktionen.length; i++) {
				copy[i] = this.funktionen[i]; // elementweises Kopieren
			}
			this.funktionen = copy; // Austausch des Arrays
		}
	}
}

public class UE17Aufgabe3 {

	public static void main(String[] args) {
		FunktionArrayList liste = new FunktionArrayList();
		liste.add(new Funktion());
		liste.add(new Funktion());
		liste.add(new QuadratFunktion());
		liste.add(new Sqrt());
		liste.ausgeben(2);
	}

}
